<html>
<head>
<title>OgreHardwareVertexBuffer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreHardwareVertexBuffer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreHardwareVertexBuffer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __HardwareVertexBuffer__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __HardwareVertexBuffer__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareBuffer_8h.html">OgreHardwareBuffer.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreColourValue_8h.html">OgreColourValue.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038     <span class="keyword">class </span>HardwareBufferManagerBase;
<a name="l00039"></a>00039 
<a name="l00047"></a><a class="code" href="classOgre_1_1HardwareVertexBuffer.html">00047</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049         <span class="keyword">protected</span>:
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classOgre_1_1HardwareVertexBuffer.html#a76962312880d3d62c29bd02db4889404">00051</a>             <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* <a class="code" href="classOgre_1_1HardwareVertexBuffer.html#a76962312880d3d62c29bd02db4889404">mMgr</a>;
<a name="l00052"></a><a class="code" href="classOgre_1_1HardwareVertexBuffer.html#a36d77550269d084792c0c863ca5e8a35">00052</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareVertexBuffer.html#a36d77550269d084792c0c863ca5e8a35">mNumVertices</a>;
<a name="l00053"></a><a class="code" href="classOgre_1_1HardwareVertexBuffer.html#ab8eb0ea0224219c41ce7630bdfa1fa8c">00053</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareVertexBuffer.html#ab8eb0ea0224219c41ce7630bdfa1fa8c">mVertexSize</a>;
<a name="l00054"></a><a class="code" href="classOgre_1_1HardwareVertexBuffer.html#aa35769af03b2b6d71ac38e8f2aaba78a">00054</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1HardwareVertexBuffer.html#aa35769af03b2b6d71ac38e8f2aaba78a">mIsInstanceData</a>;
<a name="l00055"></a><a class="code" href="classOgre_1_1HardwareVertexBuffer.html#a9b6f93aec8f3a810822de34cc1c902c7">00055</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareVertexBuffer.html#a9b6f93aec8f3a810822de34cc1c902c7">mInstanceDataStepRate</a>;           
<a name="l00057"></a>00057             <span class="keyword">virtual</span> <span class="keywordtype">bool</span> checkIfVertexInstanceDataIsSupported();
<a name="l00058"></a>00058 
<a name="l00059"></a>00059         <span class="keyword">public</span>:
<a name="l00061"></a>00061             <a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a>(<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* mgr, <span class="keywordtype">size_t</span> vertexSize, <span class="keywordtype">size_t</span> numVertices,
<a name="l00062"></a>00062                 <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> useSystemMemory, <span class="keywordtype">bool</span> useShadowBuffer);
<a name="l00063"></a>00063             ~<a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a>();
<a name="l00065"></a><a class="code" href="classOgre_1_1HardwareVertexBuffer.html#a4ed0f6954395556a3dbc5899fe5df401">00065</a>             <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* <a class="code" href="classOgre_1_1HardwareVertexBuffer.html#a4ed0f6954395556a3dbc5899fe5df401" title="Return the manager of this buffer, if any.">getManager</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMgr; }
<a name="l00067"></a><a class="code" href="classOgre_1_1HardwareVertexBuffer.html#adc5090970f3336432f181a42564855c7">00067</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareVertexBuffer.html#adc5090970f3336432f181a42564855c7" title="Gets the size in bytes of a single vertex in this buffer.">getVertexSize</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexSize; }
<a name="l00069"></a><a class="code" href="classOgre_1_1HardwareVertexBuffer.html#aadf84ce66787e07b1119e278fdd67a6e">00069</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareVertexBuffer.html#aadf84ce66787e07b1119e278fdd67a6e" title="Get the number of vertices in this buffer.">getNumVertices</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mNumVertices; }
<a name="l00071"></a><a class="code" href="classOgre_1_1HardwareVertexBuffer.html#ad1690aff2bf71373e8dca22c5161e493">00071</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1HardwareVertexBuffer.html#ad1690aff2bf71373e8dca22c5161e493" title="Get if this vertex buffer is an &quot;instance data&quot; buffer (per instance)">getIsInstanceData</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIsInstanceData; }
<a name="l00073"></a>00073             <span class="keywordtype">void</span> setIsInstanceData(<span class="keyword">const</span> <span class="keywordtype">bool</span> val);
<a name="l00075"></a>00075             <span class="keywordtype">size_t</span> getInstanceDataStepRate() <span class="keyword">const</span>;
<a name="l00077"></a>00077             <span class="keywordtype">void</span> setInstanceDataStepRate(<span class="keyword">const</span> <span class="keywordtype">size_t</span> val);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080             <span class="comment">// NB subclasses should override lock, unlock, readData, writeData</span>
<a name="l00081"></a>00081 
<a name="l00082"></a>00082     };
<a name="l00083"></a>00083 
<a name="l00085"></a><a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">00085</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;HardwareVertexBuffer&gt;
<a name="l00086"></a>00086     {
<a name="l00087"></a>00087     <span class="keyword">public</span>:
<a name="l00088"></a><a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html#afc055c7b714d21945de99e79d3cd8967">00088</a>         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html#afc055c7b714d21945de99e79d3cd8967">HardwareVertexBufferSharedPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a>&gt;() {}
<a name="l00089"></a>00089         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>(<a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a>* buf);
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092     };
<a name="l00093"></a>00093 
<a name="l00095"></a><a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d">00095</a>     <span class="keyword">enum</span> <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> {
<a name="l00097"></a><a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00dad04d50e91c2ec5377e610b3f5b9b07f2">00097</a>         <a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00dad04d50e91c2ec5377e610b3f5b9b07f2" title="Position, 3 reals per vertex.">VES_POSITION</a> = 1,
<a name="l00099"></a><a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da63d3494547f373f5c4397a41b39cf6a0">00099</a>         <a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da63d3494547f373f5c4397a41b39cf6a0" title="Blending weights.">VES_BLEND_WEIGHTS</a> = 2,
<a name="l00101"></a><a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00dae54f94c9c9cf553d227c2aab2c499bbf">00101</a>         <a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00dae54f94c9c9cf553d227c2aab2c499bbf" title="Blending indices.">VES_BLEND_INDICES</a> = 3,
<a name="l00103"></a><a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da1dec7d36a64625348e23af26c9231227">00103</a>         <a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da1dec7d36a64625348e23af26c9231227" title="Normal, 3 reals per vertex.">VES_NORMAL</a> = 4,
<a name="l00105"></a><a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00daabddc327dc0835e75b7622ee81e7f527">00105</a>         <a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00daabddc327dc0835e75b7622ee81e7f527" title="Diffuse colours.">VES_DIFFUSE</a> = 5,
<a name="l00107"></a><a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00daac8754d6241197a32c19cd72ff1806cc">00107</a>         <a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00daac8754d6241197a32c19cd72ff1806cc" title="Specular colours.">VES_SPECULAR</a> = 6,
<a name="l00109"></a><a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da17abb855311f3a67bc31414cad8d6212">00109</a>         <a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da17abb855311f3a67bc31414cad8d6212" title="Texture coordinates.">VES_TEXTURE_COORDINATES</a> = 7,
<a name="l00111"></a><a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da2b06bd6ce4e2b9115ab122e35d86502f">00111</a>         <a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da2b06bd6ce4e2b9115ab122e35d86502f" title="Binormal (Y axis if normal is Z)">VES_BINORMAL</a> = 8,
<a name="l00113"></a><a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da57d43012049b3ec7b4240b207dd029f2">00113</a>         <a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da57d43012049b3ec7b4240b207dd029f2" title="Tangent (X axis if normal is Z)">VES_TANGENT</a> = 9,
<a name="l00115"></a><a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da6f167783a26ed5d1c146fbeae995af0b">00115</a>         <a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da6f167783a26ed5d1c146fbeae995af0b" title="The number of VertexElementSemantic elements (note - the first value VES_POSITION is 1)...">VES_COUNT</a> = 9
<a name="l00116"></a>00116     };
<a name="l00117"></a>00117 
<a name="l00119"></a><a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f">00119</a>     <span class="keyword">enum</span> <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a>
<a name="l00120"></a>00120     {
<a name="l00121"></a><a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa3fbd40586beffa36887f783d401c5b83">00121</a>         <a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa3fbd40586beffa36887f783d401c5b83">VET_FLOAT1</a> = 0,
<a name="l00122"></a><a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa0993ccf616ec6e7bf60fff2ef1705ce6">00122</a>         <a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa0993ccf616ec6e7bf60fff2ef1705ce6">VET_FLOAT2</a> = 1,
<a name="l00123"></a><a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa9ccf920d2572b15896f75ccf30fb150c">00123</a>         <a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa9ccf920d2572b15896f75ccf30fb150c">VET_FLOAT3</a> = 2,
<a name="l00124"></a><a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa7f1dd8dd0e61ef81a53f5b315d096325">00124</a>         <a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa7f1dd8dd0e61ef81a53f5b315d096325">VET_FLOAT4</a> = 3,
<a name="l00126"></a><a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa2da074f4cb5af787d6fe3d7efafbda5e">00126</a>         <a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa2da074f4cb5af787d6fe3d7efafbda5e" title="alias to more specific colour type - use the current rendersystem&#39;s colour packing">VET_COLOUR</a> = 4,
<a name="l00127"></a><a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fadcf2fcc87b2ffd15476b34c54110d4f1">00127</a>         <a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fadcf2fcc87b2ffd15476b34c54110d4f1">VET_SHORT1</a> = 5,
<a name="l00128"></a><a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa95b23f7c498fc51e9b5fdf22779394bf">00128</a>         <a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa95b23f7c498fc51e9b5fdf22779394bf">VET_SHORT2</a> = 6,
<a name="l00129"></a><a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa74cfbca962869d7b2bdbe3dd869f183c">00129</a>         <a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa74cfbca962869d7b2bdbe3dd869f183c">VET_SHORT3</a> = 7,
<a name="l00130"></a><a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa0d7cffdff4ceb5440142ca43f0fedc29">00130</a>         <a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa0d7cffdff4ceb5440142ca43f0fedc29">VET_SHORT4</a> = 8,
<a name="l00131"></a><a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa634a1cefe14124d3c9c2b11d782f947c">00131</a>         <a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa634a1cefe14124d3c9c2b11d782f947c">VET_UBYTE4</a> = 9,
<a name="l00133"></a><a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa952a7cf30c1f555019dfbeb1ed2c8c41">00133</a>         <a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fa952a7cf30c1f555019dfbeb1ed2c8c41" title="D3D style compact colour.">VET_COLOUR_ARGB</a> = 10,
<a name="l00135"></a><a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fafe3711fdde45487fbac6e2f38b0b9f1b">00135</a>         <a class="code" href="group__RenderSystem.html#gga027109503a988ba85f4c63b55082907fafe3711fdde45487fbac6e2f38b0b9f1b" title="GL style compact colour.">VET_COLOUR_ABGR</a> = 11
<a name="l00136"></a>00136     };
<a name="l00137"></a>00137 
<a name="l00147"></a><a class="code" href="classOgre_1_1VertexElement.html">00147</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">VertexDataAlloc</a>
<a name="l00148"></a>00148     {
<a name="l00149"></a>00149     <span class="keyword">protected</span>:
<a name="l00151"></a><a class="code" href="classOgre_1_1VertexElement.html#aba26f25183641c5095c8f6d0831dc1ca">00151</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1VertexElement.html#aba26f25183641c5095c8f6d0831dc1ca" title="The source vertex buffer, as bound to an index using VertexBufferBinding.">mSource</a>;
<a name="l00153"></a><a class="code" href="classOgre_1_1VertexElement.html#a82f811fecda479f8b1443d5df9488a25">00153</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1VertexElement.html#a82f811fecda479f8b1443d5df9488a25" title="The offset in the buffer that this element starts at.">mOffset</a>;
<a name="l00155"></a><a class="code" href="classOgre_1_1VertexElement.html#a55d4996a5703f82020ebf05a4c5f8222">00155</a>         <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> <a class="code" href="classOgre_1_1VertexElement.html#a55d4996a5703f82020ebf05a4c5f8222" title="The type of element.">mType</a>;
<a name="l00157"></a><a class="code" href="classOgre_1_1VertexElement.html#a3f040d2e54d1dc1103a7cc3b2a0f2e9b">00157</a>         <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> <a class="code" href="classOgre_1_1VertexElement.html#a3f040d2e54d1dc1103a7cc3b2a0f2e9b" title="The meaning of the element.">mSemantic</a>;
<a name="l00159"></a><a class="code" href="classOgre_1_1VertexElement.html#a481893620cead3d8136aab24da32aa3c">00159</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1VertexElement.html#a481893620cead3d8136aab24da32aa3c" title="Index of the item, only applicable for some elements like texture coords.">mIndex</a>;
<a name="l00160"></a>00160     <span class="keyword">public</span>:
<a name="l00162"></a><a class="code" href="classOgre_1_1VertexElement.html#a91b0768c36a06062b941fedaf37901d8">00162</a>         <a class="code" href="classOgre_1_1VertexElement.html#a91b0768c36a06062b941fedaf37901d8" title="Constructor, should not be called directly, only needed because of list.">VertexElement</a>() {}
<a name="l00164"></a>00164         <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> source, <span class="keywordtype">size_t</span> offset, <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> theType,
<a name="l00165"></a>00165             <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00167"></a><a class="code" href="classOgre_1_1VertexElement.html#ac0559c14d6c048db96c1eff14cceff40">00167</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1VertexElement.html#ac0559c14d6c048db96c1eff14cceff40" title="Gets the vertex buffer index from where this element draws it&#39;s values.">getSource</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSource; }
<a name="l00169"></a><a class="code" href="classOgre_1_1VertexElement.html#affcb4cfae6944a6cb43d1a03664f4a95">00169</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1VertexElement.html#affcb4cfae6944a6cb43d1a03664f4a95" title="Gets the offset into the buffer where this element starts.">getOffset</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOffset; }
<a name="l00171"></a><a class="code" href="classOgre_1_1VertexElement.html#aea85cdaf058bc4ef4f43a21a042e8e4b">00171</a>         <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> <a class="code" href="classOgre_1_1VertexElement.html#aea85cdaf058bc4ef4f43a21a042e8e4b" title="Gets the data format of this element.">getType</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mType; }
<a name="l00173"></a><a class="code" href="classOgre_1_1VertexElement.html#aeab14d13a7368e75be776c871420cc77">00173</a>         <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> <a class="code" href="classOgre_1_1VertexElement.html#aeab14d13a7368e75be776c871420cc77" title="Gets the meaning of this element.">getSemantic</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSemantic; }
<a name="l00175"></a><a class="code" href="classOgre_1_1VertexElement.html#a14940087823ab0068a7a684c5ee6353a">00175</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1VertexElement.html#a14940087823ab0068a7a684c5ee6353a" title="Gets the index of this element, only applicable for repeating elements.">getIndex</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIndex; }
<a name="l00177"></a>00177         <span class="keywordtype">size_t</span> getSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00179"></a>00179         <span class="keyword">static</span> <span class="keywordtype">size_t</span> getTypeSize(<a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> etype);
<a name="l00181"></a>00181         <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getTypeCount(<a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> etype);
<a name="l00185"></a>00185         <span class="keyword">static</span> <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> multiplyTypeCount(<a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> baseType, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> count);
<a name="l00189"></a>00189         <span class="keyword">static</span> <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> getBaseType(<a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> multiType);
<a name="l00190"></a>00190 
<a name="l00197"></a>00197         <span class="keyword">static</span> <span class="keywordtype">void</span> convertColourValue(<a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> srcType,
<a name="l00198"></a>00198             <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> dstType, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>* ptr);
<a name="l00199"></a>00199 
<a name="l00205"></a>00205         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> convertColourValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; src,
<a name="l00206"></a>00206             <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> dst);
<a name="l00207"></a>00207 
<a name="l00209"></a>00209         <span class="keyword">static</span> <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> getBestColourVertexElementType(<span class="keywordtype">void</span>);
<a name="l00210"></a>00210 
<a name="l00211"></a><a class="code" href="classOgre_1_1VertexElement.html#a65832073a574e06903adc1101e109732">00211</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator== </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00212"></a>00212 <span class="keyword">        </span>{
<a name="l00213"></a>00213             <span class="keywordflow">if</span> (mType != rhs.<a class="code" href="classOgre_1_1VertexElement.html#a55d4996a5703f82020ebf05a4c5f8222" title="The type of element.">mType</a> ||
<a name="l00214"></a>00214                 mIndex != rhs.<a class="code" href="classOgre_1_1VertexElement.html#a481893620cead3d8136aab24da32aa3c" title="Index of the item, only applicable for some elements like texture coords.">mIndex</a> ||
<a name="l00215"></a>00215                 mOffset != rhs.<a class="code" href="classOgre_1_1VertexElement.html#a82f811fecda479f8b1443d5df9488a25" title="The offset in the buffer that this element starts at.">mOffset</a> ||
<a name="l00216"></a>00216                 mSemantic != rhs.<a class="code" href="classOgre_1_1VertexElement.html#a3f040d2e54d1dc1103a7cc3b2a0f2e9b" title="The meaning of the element.">mSemantic</a> ||
<a name="l00217"></a>00217                 mSource != rhs.<a class="code" href="classOgre_1_1VertexElement.html#aba26f25183641c5095c8f6d0831dc1ca" title="The source vertex buffer, as bound to an index using VertexBufferBinding.">mSource</a>)
<a name="l00218"></a>00218                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00219"></a>00219             <span class="keywordflow">else</span>
<a name="l00220"></a>00220                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00221"></a>00221 
<a name="l00222"></a>00222         }
<a name="l00230"></a><a class="code" href="classOgre_1_1VertexElement.html#a34d62f56827dfb288b55059696587d83">00230</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> baseVertexPointerToElement(<span class="keywordtype">void</span>* pBase, <span class="keywordtype">void</span>** pElem)<span class="keyword"> const</span>
<a name="l00231"></a>00231 <span class="keyword">        </span>{
<a name="l00232"></a>00232             <span class="comment">// The only way we can do this is to cast to char* in order to use byte offset</span>
<a name="l00233"></a>00233             <span class="comment">// then cast back to void*.</span>
<a name="l00234"></a>00234             *pElem = <span class="keyword">static_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(
<a name="l00235"></a>00235                 <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>*<span class="keyword">&gt;</span>(pBase) + mOffset);
<a name="l00236"></a>00236         }
<a name="l00244"></a><a class="code" href="classOgre_1_1VertexElement.html#a20a697dec05663dea83bdee02d9412bf">00244</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> baseVertexPointerToElement(<span class="keywordtype">void</span>* pBase, <span class="keywordtype">float</span>** pElem)<span class="keyword"> const</span>
<a name="l00245"></a>00245 <span class="keyword">        </span>{
<a name="l00246"></a>00246             <span class="comment">// The only way we can do this is to cast to char* in order to use byte offset</span>
<a name="l00247"></a>00247             <span class="comment">// then cast back to float*. However we have to go via void* because casting</span>
<a name="l00248"></a>00248             <span class="comment">// directly is not allowed</span>
<a name="l00249"></a>00249             *pElem = <span class="keyword">static_cast&lt;</span><span class="keywordtype">float</span>*<span class="keyword">&gt;</span>(
<a name="l00250"></a>00250                 <span class="keyword">static_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(
<a name="l00251"></a>00251                     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>*<span class="keyword">&gt;</span>(pBase) + mOffset));
<a name="l00252"></a>00252         }
<a name="l00253"></a>00253 
<a name="l00261"></a><a class="code" href="classOgre_1_1VertexElement.html#a676a6d854d713058757f640cf6a6ae17">00261</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> baseVertexPointerToElement(<span class="keywordtype">void</span>* pBase, <a class="code" href="group__General.html#ga8c0fefd117985c6df93c4714f370bcd6">RGBA</a>** pElem)<span class="keyword"> const</span>
<a name="l00262"></a>00262 <span class="keyword">        </span>{
<a name="l00263"></a>00263             *pElem = <span class="keyword">static_cast&lt;</span><a class="code" href="group__General.html#ga8c0fefd117985c6df93c4714f370bcd6">RGBA</a>*<span class="keyword">&gt;</span>(
<a name="l00264"></a>00264                 <span class="keyword">static_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(
<a name="l00265"></a>00265                     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>*<span class="keyword">&gt;</span>(pBase) + mOffset));
<a name="l00266"></a>00266         }
<a name="l00274"></a><a class="code" href="classOgre_1_1VertexElement.html#a5cdb660e91d8d4adbad6172e86c2562f">00274</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> baseVertexPointerToElement(<span class="keywordtype">void</span>* pBase, <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>** pElem)<span class="keyword"> const</span>
<a name="l00275"></a>00275 <span class="keyword">        </span>{
<a name="l00276"></a>00276             *pElem = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>*<span class="keyword">&gt;</span>(pBase) + mOffset;
<a name="l00277"></a>00277         }
<a name="l00278"></a>00278 
<a name="l00286"></a><a class="code" href="classOgre_1_1VertexElement.html#af3bcab57ea91e958261c618b2c8925c4">00286</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> baseVertexPointerToElement(<span class="keywordtype">void</span>* pBase, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span>** pElem)<span class="keyword"> const</span>
<a name="l00287"></a>00287 <span class="keyword">        </span>{
<a name="l00288"></a>00288             *pElem = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">short</span>*<span class="keyword">&gt;</span>(
<a name="l00289"></a>00289                 <span class="keyword">static_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(
<a name="l00290"></a>00290                     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>*<span class="keyword">&gt;</span>(pBase) + mOffset));
<a name="l00291"></a>00291         }
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00294"></a>00294     };
<a name="l00317"></a><a class="code" href="classOgre_1_1VertexDeclaration.html">00317</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">VertexDataAlloc</a>
<a name="l00318"></a>00318     {
<a name="l00319"></a>00319     <span class="keyword">public</span>:
<a name="l00321"></a><a class="code" href="classOgre_1_1VertexDeclaration.html#a3229cfa9d056740702853b27249c7181">00321</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;VertexElement&gt;::type</a> <a class="code" href="classOgre_1_1VertexDeclaration.html#a3229cfa9d056740702853b27249c7181" title="Defines the list of vertex elements that makes up this declaration.">VertexElementList</a>;
<a name="l00323"></a>00323         <span class="keyword">static</span> <span class="keywordtype">bool</span> vertexElementLess(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a>&amp; e1, <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a>&amp; e2);
<a name="l00324"></a>00324     <span class="keyword">protected</span>:
<a name="l00325"></a><a class="code" href="classOgre_1_1VertexDeclaration.html#adc48aa31318d2384866eab90ee8406d5">00325</a>         <a class="code" href="classOgre_1_1VertexDeclaration.html#a3229cfa9d056740702853b27249c7181" title="Defines the list of vertex elements that makes up this declaration.">VertexElementList</a> <a class="code" href="classOgre_1_1VertexDeclaration.html#adc48aa31318d2384866eab90ee8406d5">mElementList</a>;
<a name="l00326"></a>00326     <span class="keyword">public</span>:
<a name="l00328"></a>00328         <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>();
<a name="l00329"></a>00329         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>();
<a name="l00330"></a>00330 
<a name="l00332"></a><a class="code" href="classOgre_1_1VertexDeclaration.html#a4af70a10bb43da8b8816d18fe652ec58">00332</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1VertexDeclaration.html#a4af70a10bb43da8b8816d18fe652ec58" title="Get the number of elements in the declaration.">getElementCount</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mElementList.size(); }
<a name="l00334"></a>00334         <span class="keyword">const</span> VertexElementList&amp; getElements(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00336"></a>00336         <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a>* getElement(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00337"></a>00337 
<a name="l00346"></a>00346         <span class="keywordtype">void</span> sort(<span class="keywordtype">void</span>);
<a name="l00347"></a>00347 
<a name="l00358"></a>00358         <span class="keywordtype">void</span> closeGapsInSource(<span class="keywordtype">void</span>);
<a name="l00359"></a>00359 
<a name="l00371"></a>00371         <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* getAutoOrganisedDeclaration(<span class="keywordtype">bool</span> skeletalAnimation,
<a name="l00372"></a>00372             <span class="keywordtype">bool</span> vertexAnimation, <span class="keywordtype">bool</span> vertexAnimationNormals) <span class="keyword">const</span>;
<a name="l00373"></a>00373 
<a name="l00375"></a>00375         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getMaxSource(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00392"></a>00392         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a>&amp; addElement(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> source, <span class="keywordtype">size_t</span> offset, <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> theType,
<a name="l00393"></a>00393             <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00407"></a>00407         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a>&amp; insertElement(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> atPosition,
<a name="l00408"></a>00408             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> source, <span class="keywordtype">size_t</span> offset, <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> theType,
<a name="l00409"></a>00409             <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00410"></a>00410 
<a name="l00412"></a>00412         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeElement(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> elem_index);
<a name="l00413"></a>00413 
<a name="l00420"></a>00420         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeElement(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00421"></a>00421 
<a name="l00423"></a>00423         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAllElements(<span class="keywordtype">void</span>);
<a name="l00424"></a>00424 
<a name="l00430"></a>00430         <span class="keyword">virtual</span> <span class="keywordtype">void</span> modifyElement(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> elem_index, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> source, <span class="keywordtype">size_t</span> offset, <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> theType,
<a name="l00431"></a>00431             <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00432"></a>00432 
<a name="l00438"></a>00438         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a>* findElementBySemantic(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> sem, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0) <span class="keyword">const</span>;
<a name="l00448"></a>00448         <span class="keyword">virtual</span> VertexElementList findElementsBySource(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> source) <span class="keyword">const</span>;
<a name="l00449"></a>00449 
<a name="l00451"></a>00451         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getVertexSize(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> source) <span class="keyword">const</span>;
<a name="l00452"></a>00452         
<a name="l00456"></a>00456         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNextFreeTextureCoordinate() <span class="keyword">const</span>;
<a name="l00457"></a>00457 
<a name="l00462"></a>00462         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* clone(<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* mgr = 0) <span class="keyword">const</span>;
<a name="l00463"></a>00463 
<a name="l00464"></a><a class="code" href="classOgre_1_1VertexDeclaration.html#aee364dc39b2dfdbff4a5b135e5e5ef39">00464</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator== </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00465"></a>00465 <span class="keyword">        </span>{
<a name="l00466"></a>00466             <span class="keywordflow">if</span> (mElementList.size() != rhs.<a class="code" href="classOgre_1_1VertexDeclaration.html#adc48aa31318d2384866eab90ee8406d5">mElementList</a>.size())
<a name="l00467"></a>00467                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00468"></a>00468 
<a name="l00469"></a>00469             VertexElementList::const_iterator i, iend, rhsi, rhsiend;
<a name="l00470"></a>00470             iend = mElementList.end();
<a name="l00471"></a>00471             rhsiend = rhs.<a class="code" href="classOgre_1_1VertexDeclaration.html#adc48aa31318d2384866eab90ee8406d5">mElementList</a>.end();
<a name="l00472"></a>00472             rhsi = rhs.<a class="code" href="classOgre_1_1VertexDeclaration.html#adc48aa31318d2384866eab90ee8406d5">mElementList</a>.begin();
<a name="l00473"></a>00473             <span class="keywordflow">for</span> (i = mElementList.begin(); i != iend &amp;&amp; rhsi != rhsiend; ++i, ++rhsi)
<a name="l00474"></a>00474             {
<a name="l00475"></a>00475                 <span class="keywordflow">if</span> ( !(*i == *rhsi) )
<a name="l00476"></a>00476                     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00477"></a>00477             }
<a name="l00478"></a>00478 
<a name="l00479"></a>00479             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00480"></a>00480         }
<a name="l00481"></a><a class="code" href="classOgre_1_1VertexDeclaration.html#a64989816c9979aac5a5416d488d547d5">00481</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator!= </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00482"></a>00482 <span class="keyword">        </span>{
<a name="l00483"></a>00483             <span class="keywordflow">return</span> !(*<span class="keyword">this</span> == rhs);
<a name="l00484"></a>00484         }
<a name="l00485"></a>00485 
<a name="l00486"></a>00486     };
<a name="l00487"></a>00487 
<a name="l00501"></a><a class="code" href="classOgre_1_1VertexBufferBinding.html">00501</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">VertexDataAlloc</a>
<a name="l00502"></a>00502     {
<a name="l00503"></a>00503     <span class="keyword">public</span>:
<a name="l00505"></a><a class="code" href="classOgre_1_1VertexBufferBinding.html#a37652e6079944fcd979d2e8c030f27fc">00505</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;unsigned short, HardwareVertexBufferSharedPtr&gt;::type</a> <a class="code" href="classOgre_1_1VertexBufferBinding.html#a37652e6079944fcd979d2e8c030f27fc" title="Defines the vertex buffer bindings used as source for vertex declarations.">VertexBufferBindingMap</a>;
<a name="l00506"></a>00506     <span class="keyword">protected</span>:
<a name="l00507"></a><a class="code" href="classOgre_1_1VertexBufferBinding.html#a98d222f14c8b30e9a1ad5c46ad2ca7ef">00507</a>         <a class="code" href="classOgre_1_1VertexBufferBinding.html#a37652e6079944fcd979d2e8c030f27fc" title="Defines the vertex buffer bindings used as source for vertex declarations.">VertexBufferBindingMap</a> <a class="code" href="classOgre_1_1VertexBufferBinding.html#a98d222f14c8b30e9a1ad5c46ad2ca7ef">mBindingMap</a>;
<a name="l00508"></a><a class="code" href="classOgre_1_1VertexBufferBinding.html#a27f847c54c66dd68bea6fbb203c22bd1">00508</a>         <span class="keyword">mutable</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1VertexBufferBinding.html#a27f847c54c66dd68bea6fbb203c22bd1">mHighIndex</a>;
<a name="l00509"></a>00509     <span class="keyword">public</span>:
<a name="l00511"></a>00511         <a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>();
<a name="l00512"></a>00512         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>();
<a name="l00521"></a>00521         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setBinding(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; buffer);
<a name="l00523"></a>00523         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unsetBinding(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00524"></a>00524 
<a name="l00526"></a>00526         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unsetAllBindings(<span class="keywordtype">void</span>);
<a name="l00527"></a>00527 
<a name="l00529"></a>00529         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexBufferBinding.html#a37652e6079944fcd979d2e8c030f27fc" title="Defines the vertex buffer bindings used as source for vertex declarations.">VertexBufferBindingMap</a>&amp; getBindings(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00530"></a>00530 
<a name="l00532"></a>00532         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; getBuffer(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00534"></a>00534         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isBufferBound(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00535"></a>00535 
<a name="l00536"></a><a class="code" href="classOgre_1_1VertexBufferBinding.html#af570a9fe722354b2dc83b1f529019499">00536</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1VertexBufferBinding.html#af570a9fe722354b2dc83b1f529019499">getBufferCount</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mBindingMap.size(); }
<a name="l00537"></a>00537 
<a name="l00543"></a><a class="code" href="classOgre_1_1VertexBufferBinding.html#a3976e5c953660dc5ac4ec9e2a962779e">00543</a>         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1VertexBufferBinding.html#a3976e5c953660dc5ac4ec9e2a962779e" title="Gets the highest index which has already been set, plus 1.">getNextIndex</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHighIndex++; }
<a name="l00544"></a>00544 
<a name="l00547"></a>00547         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getLastBoundIndex(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00548"></a>00548 
<a name="l00549"></a><a class="code" href="classOgre_1_1VertexBufferBinding.html#ac3ab943f844cb170582c70f2b7a9c9af">00549</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">map&lt;ushort, ushort&gt;::type</a> <a class="code" href="classOgre_1_1VertexBufferBinding.html#ac3ab943f844cb170582c70f2b7a9c9af">BindingIndexMap</a>;
<a name="l00550"></a>00550 
<a name="l00553"></a>00553         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasGaps(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00554"></a>00554 
<a name="l00567"></a>00567         <span class="keyword">virtual</span> <span class="keywordtype">void</span> closeGaps(<a class="code" href="classOgre_1_1VertexBufferBinding.html#ac3ab943f844cb170582c70f2b7a9c9af">BindingIndexMap</a>&amp; bindingIndexMap);
<a name="l00568"></a>00568 
<a name="l00570"></a>00570         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getHasInstanceData() <span class="keyword">const</span>;
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 
<a name="l00573"></a>00573     };
<a name="l00579"></a>00579 }
<a name="l00580"></a>00580 <span class="preprocessor">#endif</span>
<a name="l00581"></a>00581 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
